	INCLUDE "constants.bas"

title_screen_setup:
	MODE 1	
	WAIT
	DEFINE 0,16,title_screen_bitmaps_0
	WAIT
	DEFINE 16,16,title_screen_bitmaps_1
	WAIT
	DEFINE 32,16,title_screen_bitmaps_2
	WAIT
	DEFINE 48,7,title_screen_bitmaps_3
	WAIT
	DEFINE 63,1,copyrightsymbol
	SCREEN title_screen_cards
	wait
	PLAY FULL
	play titlesong

	print at 20 color $2207,"CHRIS READ GIVES YOU"
	print at 200 color $2207,"\319 2018 BY CHRIS READ"

title_screen_main:
	if cont.b0 then gosub checkfornokeys2 : goto main_game_setup
	
	wait
	
	goto title_screen_main

main_game_setup:
	PLAY OFF
	DEFINE 0,14,screen_bitmaps_0
	WAIT
	DEFINE 23,1,window
	WAIT
	DEFINE 24,1,everything
	WAIT
	DEFINE 25,3,roulettewheel
	WAIT
	SCREEN screen_cards
	wait

	dim sframe(5), sy(5), sx(5), sstoplimit(5), sstop(5)
	
	moneyhun=10 : moneyone=0
	spinning=0
	sx(0)=44 : sx(1)=60 : sx(2)=76 : sx(3)=92 : sx(4)=108
	
	for a = 0 to 4
		sframe(a)=random(2)+1
		sy(a)=36
		
		if sframe(a)=1 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR25+BEHIND+2
		if sframe(a)=2 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR26+BEHIND+6
		if sframe(a)=3 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR27+BEHIND+$1003	
	next a

	goto loop

new_spin:
	sstoplimit(0)=random(8)+2
	sstoplimit(1)=sstoplimit(0)+random(8)+2	
	sstoplimit(2)=sstoplimit(1)+random(8)+2
	sstoplimit(3)=sstoplimit(2)+random(8)+2
	sstoplimit(4)=sstoplimit(3)+random(8)+2

	for a = 0 to 4
		sstop(a)=0
	next a

	sfxtimer=0

	moneyone=moneyone-1
	if moneyone>99 then moneyhun=moneyhun-1 : moneyone=99

	play slotmachinegoing

loop:
	if spinning=1 then
	
		for a=0 to 4
			if sstoplimit(a)=sstop(a) and sy(a)<>36 then sy(a)=sy(a)+1
			if sstoplimit(a)=sstop(a) and sy(a)=34 then sfxtimer=1
			if sfxtimer>0 then sfxtimer=sfxtimer+1 : sound 2,100,15 else sound 2,1,0
			if sfxtimer>29 then sfxtimer=0 
			if sstop(a)<sstoplimit(a) then sy(a)=sy(a)+1 
			if sy(a)>48 then sy(a)=24 : sframe(a)=sframe(a)+1 : sstop(a)=sstop(a)+1
			if sframe(a)=4 then sframe(a)=1
			if sframe(a)=1 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR25+BEHIND+2
			if sframe(a)=2 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR26+BEHIND+6
			if sframe(a)=3 then SPRITE a,sx(a)+VISIBLE,sy(a)+ZOOMY2,SPR27+BEHIND+$1003
		next a
	end if

	if sstoplimit(4)=sstop(4) and sy(4)=36 and spinning=1 then gosub amount_won

	if pullinghandle>0 then pullinghandle=pullinghandle+1 
 
	if pullinghandle>30 then SCREEN screen_cards : pullinghandle=0 
	
		print at 227 color $1202,"$",<2>moneyhun,<2>moneyone
	
		WAIT
		
	if cont.b0 and spinning=0 then SCREEN screen_cards_handle_pulled : pullinghandle=1 : print at 227 color $1202,"$",<2>moneyhun,<2>moneyone : wait : spinning=1 : gosub checkfornokeys





	GOTO loop

amount_won: procedure
	PLAY OFF

	amount=0
	
	if sframe(0)=sframe(1) and sframe(1)=sframe(2) then amount=10
	if sframe(1)=sframe(2) and sframe(2)=sframe(3) then amount=10	
	if sframe(2)=sframe(3) and sframe(3)=sframe(4) then amount=10
	if sframe(0)=sframe(1) and sframe(1)=sframe(2) and sframe(2)=sframe(3) then amount=20
	if sframe(1)=sframe(2) and sframe(2)=sframe(3) and sframe(3)=sframe(4) then amount=20
	if sframe(0)=sframe(1) and sframe(1)=sframe(2) and sframe(2)=sframe(3) and sframe(3)=sframe(4) then amount=30

	if amount=0 then play slotmachineloss else play slotmachinewin

	moneyone=moneyone+amount
	if moneyone>99 then moneyhun=moneyhun+1 : moneyone=moneyone-99

	spinning=0

	return
	end

checkfornokeys2: Procedure
	Rem this procedure is to make sure the key buffer is cleared so presses don't fall thru.
	clearloop2:
	k=cont
	wait
	if k then goto clearloop2
	
	wait
end	

checkfornokeys: Procedure
	Rem this procedure is to make sure the key buffer is cleared so presses don't fall thru.
	clearloop:

	k=cont
	print at 227 color $1202,"$",<2>moneyhun,<2>moneyone	
	wait
	if k then goto clearloop
	print at 227 color $1202,"$",<2>moneyhun,<2>moneyone
	wait
	goto new_spin 
	
	wait
end	

titlesong: data 20
	music e5,c3,-,m2
	music c5,g3,-,m3
	music d5,g2,-,m2
	music e5,g3,-,m3
	music d5,c3,-,m2
	music c5,g3,-,m3
	music b4,g2,-,m2
	music -,g3,-,m3
	music g4,b2,-,m2
	music g4,g3,-,m3
	music e5,g2,-,m2
	music d5,g3,-,m3
	music b4,b3,-,m2
	music a4,g3,-,m3
	music g4,g2,-,m2
	music -,g3,-,m3

	music e5,c3,-,m2
	music c5,g3,-,m3
	music d5,g2,-,m2
	music e5,g3,-,m3
	music d5,c3,-,m2
	music c5,g3,-,m3
	music b4,g2,-,m2
	music -,g3,-,m3
	music g4,b2,-,m2
	music g4,g3,-,m3
	music a4,g2,-,m2
	music b4,g3,-,m3
	music c5,c3,-,m2
	music g4,g3,-,m3
	music c5,e3,-,m2
	music -,d3,-,m3
	music repeat

slotmachinegoing: data 7
	MUSIC C5Y,C4X,-
	MUSIC B4,B3,-
	MUSIC A4,A3,-
	MUSIC G4,G3,-
	MUSIC A4,A3,-
	MUSIC B4,B3,-
	MUSIC REPEAT

slotmachineloss: data 10
	MUSIC E3,-
	MUSIC S,-
	MUSIC S,-
	MUSIC D3,-
	MUSIC C3,-
	MUSIC S,-
	MUSIC A2,-
	MUSIC -,-
	MUSIC A2,-
	MUSIC -,-
	MUSIC -,-
	MUSIC STOP
	
slotmachinewin: data 10
	music E4,C3
	MUSIC S,-
	music C4,-
	music S,-
	MUSIC E4,G3
	MUSIC S,-
	MUSIC G4,-
	MUSIC S,-	
	MUSIC C5,C3
	MUSIC E4,-
	MUSIC D4,-
	MUSIC C4,-
	MUSIC S,-	
	music stop

	' 14 bitmaps
screen_bitmaps_0:
	DATA $0300,$0F07,$3F1F,$FF7F
	DATA $FF00,$FFFF,$FFFF,$FFFF
	DATA $E000,$F8F0,$FEFC,$FFFF
	DATA $0000,$0000,$0000,$8000
	DATA $7F7F,$7F7F,$7F7F,$7F7F
	DATA $FFFF,$C0E1,$C0C0,$E1C0
	DATA $0C0C,$0C0C,$0C0C,$0C0C
	DATA $0100,$0703,$1F0F,$7F3F
	DATA $C080,$F0E0,$FCF8,$FFFE
	DATA $80FF,$8080,$8080,$8080
	DATA $00FF,$0000,$0000,$0000
	DATA $8C8C,$8C8C,$8C8C,$8C8C
	DATA $8080,$8080,$8080,$8080
	DATA $FC8C,$80F8,$8080,$8080

	REM 20x12 cards
screen_cards:
	DATA $0000,$0000,$0000,$0000,$0801,$0809,$0809,$0809,$0809,$0809,$0809,$0809,$0809,$0811,$0819,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2A20,$0000,$1A28,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1A20,$0000,$0831,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0839,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0841,$0000,$0831,$0000,$0000,$0000
	DATA $0000,$0000,$0839,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0841,$0831,$0000,$0000,$0000
	DATA $0000,$0000,$1A49,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$0859,$0000,$0000,$0000
	DATA $0000,$0000,$1A61,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$0869,$0000,$0000,$0000
	DATA $0000,$0000,$1A61,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$0861,$0000,$0000,$0000
	
screen_cards_handle_pulled:
	DATA $0000,$0000,$0000,$0000,$0801,$0809,$0809,$0809,$0809,$0809,$0809,$0809,$0809,$0811,$0819,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2EBD,$2600,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2AC5,$2A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1A20,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0839,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0841,$0000,$1A28,$0000,$0000,$0000
	DATA $0000,$0000,$0839,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0200,$0841,$0831,$0000,$0000,$0000
	DATA $0000,$0000,$1A49,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$1A51,$0859,$0000,$0000,$0000
	DATA $0000,$0000,$1A61,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$0869,$0000,$0000,$0000
	DATA $0000,$0000,$1A61,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$1200,$0861,$0000,$0000,$0000	

	'55 bitmaps
title_screen_bitmaps_0:
	DATA $0000,$0000,$0100,$0303
	DATA $0000,$0000,$F8F0,$0EFC
	DATA $0000,$0000,$0000,$0800
	DATA $0000,$0000,$3818,$E070
	DATA $0000,$0000,$0000,$3800
	DATA $0000,$0000,$0000,$FC7C
	DATA $0000,$3000,$3830,$6E7C
	DATA $0000,$0000,$0100,$0301
	DATA $0707,$0303,$F8F1,$0C9C
	DATA $0307,$C101,$3FFF,$0100
	DATA $B918,$E3F1,$66E3,$3676
	DATA $80C0,$7FBC,$C667,$FDCC
	DATA $CD7D,$89C1,$FF9D,$1CFF
	DATA $8C84,$9F8F,$F0FB,$00C0
	DATA $C767,$B7C3,$0C3E,$0000
	DATA $0303,$0101,$0301,$0E07
title_screen_bitmaps_1:
	DATA $1C0C,$F73B,$CCEC,$CCCC
	DATA $0303,$27E3,$6646,$7D6D
	DATA $9DBF,$DC9C,$6C6C,$E06C
	DATA $F7FB,$3D7E,$0301,$0303
	DATA $6C3C,$CCCC,$088C,$3818
	DATA $80C1,$1F0C,$8107,$F8E0
	DATA $E3E3,$E3E3,$E3E3,$63E3
	DATA $FFFF,$C3FF,$1881,$1818
	DATA $C7FF,$81C7,$C781,$C7C7
	DATA $F8F8,$F8F8,$F8F8,$F8F8
	DATA $7878,$3030,$0030,$8400
	DATA $7F7F,$787F,$7170,$787E
	DATA $FFFF,$1FFF,$8C0E,$0C0C
	DATA $FEFE,$06FE,$2202,$7E7E
	DATA $3F3F,$033F,$1101,$3131
	DATA $8F8F,$8CFF,$8C8C,$8C8C
title_screen_bitmaps_2:
	DATA $FFFF,$07FF,$2303,$6363
	DATA $FFFF,$C3FF,$1881,$0000
	DATA $181C,$0110,$0607,$0C04
	DATA $63C7,$FEF8,$33FF,$3030
	DATA $80F8,$0000,$0000,$0000
	DATA $00C0,$0000,$0000,$0000
	DATA $0001,$0000,$0000,$0000
	DATA $E0F0,$0000,$0000,$0000
	DATA $183C,$8100,$FFFF,$FFFF
	DATA $6363,$E3E3,$FFFF,$FFFF
	DATA $1818,$C381,$FFFF,$FFFF
	DATA $C7C7,$E1C1,$FFFF,$FFFF
	DATA $F8F8,$F8F8,$FFFF,$FFFF
	DATA $8484,$CCCC,$FFFF,$FFFF
	DATA $7171,$7870,$FFFF,$FFFF
	DATA $8C8C,$0F0E,$FFFF,$FFFF
title_screen_bitmaps_3:
	DATA $227E,$0602,$FFFF,$FFFF
	DATA $3131,$3131,$FFFF,$FFFF
	DATA $8C8C,$8C8C,$FFFF,$FFFF
	DATA $6363,$6363,$FFFF,$FFFF
	DATA $181F,$C381,$FFFF,$FFFF
	DATA $0706,$0003,$0000,$0000
	DATA $E060,$00C0,$0000,$0000

	REM 20x12 cards
title_screen_cards:
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2A02,$2A0A,$2A12,$2A1A,$2A22,$2A2A,$2A32,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2A3A,$2A42,$2A4A,$2A52,$2A5A,$2A62,$2A6A,$2A72,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2A7A,$2A82,$2A8A,$2A92,$2A9A,$2AA2,$2200,$2EAD,$2EB5,$2EBD,$2EC5,$2ECD,$2ED5,$2EDD,$2EE5,$2EED,$2EF5,$2EFD,$2F05,$2F0D
	DATA $2B12,$2B1A,$2B22,$2B2A,$2B32,$2B3A,$2200,$2F45,$2F4D,$2F55,$2F5D,$2F65,$2F6D,$2F75,$2F7D,$2F85,$2F8D,$2F95,$2F9D,$2FA5
	DATA $2BAA,$2BB2,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	DATA $2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200,$2200
	
copyrightsymbol:
	bitmap "01111110"
	bitmap "10000001"
	bitmap "10011101"
	bitmap "10100001"
	bitmap "10100001"
	bitmap "10011101"
	bitmap "10000001"
	bitmap "01111110"
	
window:
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	bitmap "10000000"
	
everything:
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	bitmap "11111111"
	
roulettewheel:
	bitmap "11111011"
	bitmap "11111111"
	bitmap "11000110"
	bitmap "11000110"
	bitmap "00001100"
	bitmap "00011100"
	bitmap "00111100"
	bitmap "00111100"
	
	bitmap "00011000"
	bitmap "00111100"
	bitmap "01111110"
	bitmap "01111110"
	bitmap "01111110"
	bitmap "01011110"
	bitmap "00101100"
	bitmap "00011000"	
	
	bitmap "00011000"
	bitmap "00011000"
	bitmap "00111100"
	bitmap "00111100"
	bitmap "01111110"
	bitmap "01010010"
	bitmap "01000010"
	bitmap "00111100"